image: registry.gitlab.com/maeva.vignon11/lewell:latest

services:
  - mysql:5.7

variables:
  MYSQL_DATABASE: lewell
  MYSQL_ROOT_PASSWORD: root
  DB_HOST: mysql
  DB_USERNAME: root

stages:
  - build
  - test
  - deploy

build:
  stage: build
  script:
    - cp .env.example .env
    - cat .env
    - composer install --no-interaction --prefer-dist --optimize-autoloader
    - php artisan key:generate --force
    - php artisan config:cache
    - php artisan migrate --force

unit_test:
  stage: test
  script:
    - cp .env.example .env 
    - cat .env
    - composer install
    - php artisan key:generate
    - php artisan config:cache
    - php artisan migrate:fresh --force
    - php artisan db:seed --force
    - vendor/bin/phpunit

deploy_production:
  stage: deploy
  script:
    - 'which ssh-agent || ( apt-get update -y && apt-get install openssh-client -y )'
    - eval $(ssh-agent -s)
    - ssh-add <(echo "$SSH_PRIVATE_KEY")
    - mkdir -p ~/.ssh
    - '[[ -f /.dockerenv ]] && echo -e "Host *\n\tStrictHostKeyChecking no\n\n" > ~/.ssh/config'
    - ~/.composer/vendor/bin/envoy run deploy
  environment:
    name: production
    url: http://4.233.83.138
  when: manual
  only:
    - main 